-- #####################################################################
--  KAP3: bung 1
-- #####################################################################

SELECT k.ORT, k.KUNDE_NR, k.VORNAME, k.NACHNAME, SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
FROM TBL_KUNDE k
  JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
GROUP BY ROLLUP(k.ORT, (k.KUNDE_NR, k.VORNAME, k.NACHNAME));

-- #####################################################################
--  KAP3: bung 2
-- #####################################################################

SELECT convert(VARCHAR(6), BESTELL_DATUM,112) AS MONAT, 
       k.KUNDE_NR, k.VORNAME, k.NACHNAME,  COUNT(B.BESTELLUNG_NR) AS ANZ_BEST
FROM TBL_KUNDE k
  JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
GROUP BY ROLLUP(convert(VARCHAR(6), BESTELL_DATUM,112), (k.KUNDE_NR, k.VORNAME, k.NACHNAME));

-- #####################################################################
--  KAP3: bung 3
-- #####################################################################

SELECT convert(VARCHAR(6), BESTELL_DATUM,112) AS MONAT, 
       k.KUNDE_NR, k.VORNAME, k.NACHNAME, 
       SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
FROM TBL_KUNDE k
  JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
GROUP BY CUBE(convert(VARCHAR(6), BESTELL_DATUM,112), (k.KUNDE_NR, k.VORNAME, k.NACHNAME));

-- #####################################################################
--  KAP3: bung 4
-- #####################################################################

SELECT convert(VARCHAR(6), BESTELL_DATUM,112) AS MONAT, 
       k.KUNDE_NR, k.VORNAME, k.NACHNAME, 
       p.PRODUKT_NR, p.BEZEICHNUNG,
       SUM(bp.ANZAHL*p.PREIS) AS UMSATZ,
       GROUPING(k.KUNDE_NR) AS GRP_KUNDE,
       GROUPING(p.PRODUKT_NR) AS GRP_PROD,
       GROUPING(convert(VARCHAR(6), BESTELL_DATUM,112)) AS GRP_MONAT
FROM TBL_KUNDE k
  JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
GROUP BY CUBE(convert(VARCHAR(6), BESTELL_DATUM,112), (k.KUNDE_NR, k.VORNAME, k.NACHNAME), (p.PRODUKT_NR, p.BEZEICHNUNG))
HAVING  (GROUPING(k.KUNDE_NR)=0 AND GROUPING(p.PRODUKT_NR)=0 AND GROUPING(convert(VARCHAR(6), BESTELL_DATUM,112))=0) OR -- Ebene Kunde/Produkt/Monat
        (GROUPING(k.KUNDE_NR)=1 AND GROUPING(p.PRODUKT_NR)=1 AND GROUPING(convert(VARCHAR(6), BESTELL_DATUM,112))=0) OR -- Ebene Monat
        (GROUPING(k.KUNDE_NR)=0 AND GROUPING(p.PRODUKT_NR)=1 AND GROUPING(convert(VARCHAR(6), BESTELL_DATUM,112))=1) OR -- Ebene Kunde
        (GROUPING(k.KUNDE_NR)=1 AND GROUPING(p.PRODUKT_NR)=1 AND GROUPING(convert(VARCHAR(6), BESTELL_DATUM,112))=1)    -- Ebene Gesamt
		;


-- #####################################################################
--  KAP3: bung 5
-- #####################################################################

SELECT convert(VARCHAR(6), BESTELL_DATUM,112) AS MONAT, 
       k.ORT, 
       SUM(bp.ANZAHL*p.PREIS) AS UMSATZ,
       GROUPING_ID(k.ORT, convert(VARCHAR(6), BESTELL_DATUM,112)) AS GRP_ID
FROM TBL_KUNDE k
  JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
GROUP BY CUBE(convert(VARCHAR(6), BESTELL_DATUM,112), k.ORT)
HAVING GROUPING_ID(k.ORT, convert(VARCHAR(6), BESTELL_DATUM,112))<>3;

-- #####################################################################
--  KAP3: bung 6
-- #####################################################################

SELECT to_char(b.BESTELL_DATUM,'YYYYQ') AS QUARTAL, 
       k.ORT, 
       SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
FROM TBL_KUNDE k
  JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
GROUP BY GROUPING SETS(to_char(b.BESTELL_DATUM,'YYYYQ'), k.ORT)
ORDER BY to_char(b.BESTELL_DATUM,'YYYYQ') NULLS FIRST, ORT NULLS FIRST;

-- #####################################################################
--  KAP3: Aufgabe 1
-- #####################################################################


SELECT  convert(VARCHAR(4), BESTELL_DATUM,112) AS JAHR, 
        convert(VARCHAR(4), BESTELL_DATUM,112)+
					CASE 
						WHEN substring(convert(VARCHAR(6), BESTELL_DATUM,112),5,2) IN(1,2,3) THEN '1' 
						WHEN substring(convert(VARCHAR(6), BESTELL_DATUM,112),5,2) IN(4,5,6) THEN '2'
						WHEN substring(convert(VARCHAR(6), BESTELL_DATUM,112),5,2) IN(7,8,9) THEN '3'
						ELSE '4'
					END AS QUARTAL, 
        convert(VARCHAR(6), BESTELL_DATUM,112) AS MONAT, 
        SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
FROM TBL_BESTELLUNG b
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
GROUP BY ROLLUP(convert(VARCHAR(4), BESTELL_DATUM,112), convert(VARCHAR(4), BESTELL_DATUM,112)+
					CASE 
						WHEN substring(convert(VARCHAR(6), BESTELL_DATUM,112),5,2) IN(1,2,3) THEN '1' 
						WHEN substring(convert(VARCHAR(6), BESTELL_DATUM,112),5,2) IN(4,5,6) THEN '2'
						WHEN substring(convert(VARCHAR(6), BESTELL_DATUM,112),5,2) IN(7,8,9) THEN '3'
						ELSE '4'
					END, convert(VARCHAR(6), BESTELL_DATUM,112));

-- #####################################################################
--  KAP3: Aufgabe 2
-- #####################################################################

SELECT convert(VARCHAR(6), BESTELL_DATUM,112) AS MONAT, 
       k.KUNDE_NR, k.VORNAME, k.NACHNAME, 
       SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
FROM TBL_KUNDE k
  JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
GROUP BY CUBE(convert(VARCHAR(6), BESTELL_DATUM,112), (k.KUNDE_NR, k.VORNAME, k.NACHNAME));

-- #####################################################################
--  KAP3: Aufgabe 3
-- #####################################################################

SELECT convert(VARCHAR(6), BESTELL_DATUM,112) AS MONAT, 
       k.ORT,
       pg.PRODUKT_GRUPPE_NR, pg.BEZEICHNUNG,
       SUM(bp.ANZAHL*p.PREIS) AS UMSATZ,
       GROUPING_ID(convert(VARCHAR(6), BESTELL_DATUM,112), k.ORT, pg.PRODUKT_GRUPPE_NR) AS GRP_ID
FROM TBL_KUNDE k
  JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
  JOIN TBL_PRODUKTGRUPPE pg ON p.PRODUKT_GRUPPE_NR=pg.PRODUKT_GRUPPE_NR
GROUP BY CUBE(convert(VARCHAR(6), BESTELL_DATUM,112), k.ORT, (pg.PRODUKT_GRUPPE_NR, pg.BEZEICHNUNG))
HAVING GROUPING_ID(convert(VARCHAR(6), BESTELL_DATUM,112), k.ORT, pg.PRODUKT_GRUPPE_NR) IN(0,1,5,6,7);

-- #####################################################################
--  KAP3: Aufgabe 4
-- #####################################################################

SELECT convert(VARCHAR(6), BESTELL_DATUM,112) AS MONAT, 
       k.KUNDE_NR, k.VORNAME, k.NACHNAME, 
       p.PRODUKT_NR, p.BEZEICHNUNG,
       SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
FROM TBL_KUNDE k
  JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
GROUP BY GROUPING SETS(convert(VARCHAR(6), BESTELL_DATUM,112),(p.PRODUKT_NR,p.BEZEICHNUNG), (k.KUNDE_NR, k.VORNAME, k.NACHNAME));
