-- #####################################################################
--  KAP2: bung 1
-- #####################################################################

SELECT DISTINCT
    convert(VARCHAR(6), BESTELL_DATUM,112) AS MONAT,
    SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY convert(VARCHAR(6), BESTELL_DATUM,112)) AS UMSATZ
FROM TBL_BESTELLUNG b
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
WHERE convert(VARCHAR(4), BESTELL_DATUM,112)='2013'
ORDER BY 1;

-- #####################################################################
--  KAP2: bung 2
-- #####################################################################

SELECT DISTINCT
    p.PRODUKT_NR,
    p.BEZEICHNUNG,
    SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY p.PRODUKT_NR) AS UMSATZ,
    SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY p.PRODUKT_GRUPPE_NR) AS UMSATZ_PG,
    round(SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY p.PRODUKT_NR)/
    SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY p.PRODUKT_GRUPPE_NR)*100,1) AS ANTEIL
FROM TBL_BESTELLUNG b
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
WHERE convert(VARCHAR(6), BESTELL_DATUM,112) between '201304' and '201306'
ORDER BY 1;

-- #####################################################################
--  KAP2: bung 3
-- #####################################################################

SELECT DISTINCT
        MONAT,
        MAX(UMSATZ_TAG) OVER(PARTITION BY MONAT) AS MAX_UMSATZ,
        MIN(UMSATZ_TAG) OVER(PARTITION BY MONAT) AS MIN_UMSATZ,        
        UMSATZ_MONAT,
        UMSATZ_QUARTAL,
        ANTEIL
FROM (
    SELECT DISTINCT
        b.BESTELL_DATUM,
        convert(VARCHAR(6), BESTELL_DATUM,112) AS MONAT,
        SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY convert(VARCHAR(8), BESTELL_DATUM,112)) AS UMSATZ_TAG,
        SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY convert(VARCHAR(6), BESTELL_DATUM,112)) AS UMSATZ_MONAT,
        SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY convert(VARCHAR(4), BESTELL_DATUM,112)+
												CASE 
													WHEN substring(convert(VARCHAR(6), BESTELL_DATUM,112),5,2) IN(1,2,3) THEN '1' 
													WHEN substring(convert(VARCHAR(6), BESTELL_DATUM,112),5,2) IN(4,5,6) THEN '2'
													WHEN substring(convert(VARCHAR(6), BESTELL_DATUM,112),5,2) IN(7,8,9) THEN '3'
													ELSE '4'
												END
					) AS UMSATZ_QUARTAL,
        round(SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY convert(VARCHAR(6), BESTELL_DATUM,112))/
        SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY convert(VARCHAR(4), BESTELL_DATUM,112)+
												CASE 
													WHEN substring(convert(VARCHAR(6), BESTELL_DATUM,112),5,2) IN(1,2,3) THEN '1' 
													WHEN substring(convert(VARCHAR(6), BESTELL_DATUM,112),5,2) IN(4,5,6) THEN '2'
													WHEN substring(convert(VARCHAR(6), BESTELL_DATUM,112),5,2) IN(7,8,9) THEN '3'
													ELSE '4'
												END)*100,1) AS ANTEIL
    FROM TBL_BESTELLUNG b
      JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
      JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
    WHERE convert(VARCHAR(6), BESTELL_DATUM,112) between '201301' and '201303'
) umsatz
ORDER BY 1;

-- #####################################################################
--  KAP2: bung 4
-- #####################################################################

SELECT DISTINCT
          MONAT,
          ANZ_BEST,
          SUM(ANZ_BEST) OVER(PARTITION BY substring(MONAT,1,4) 
                             ORDER BY MONAT
                             ROWS BETWEEN UNBOUNDED PRECEDING AND CURRENT ROW
                            ) AS ANZ_BEST_KUM
FROM (          
      SELECT  convert(VARCHAR(6), BESTELL_DATUM,112) AS MONAT,
              COUNT(b.BESTELLUNG_NR) AS ANZ_BEST
      FROM TBL_BESTELLUNG b
      WHERE convert(VARCHAR(4), BESTELL_DATUM,112)='2013'
      GROUP BY convert(VARCHAR(6), BESTELL_DATUM,112)
) best
ORDER BY 1;

-- #####################################################################
--  KAP2: bung 5
-- #####################################################################

SELECT DISTINCT
        b.BESTELL_DATUM,
        SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY b.BESTELL_DATUM) AS UMSATZ,
        SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY convert(VARCHAR(6), BESTELL_DATUM,112)
                                    ORDER BY b.BESTELL_DATUM
                                    RANGE BETWEEN UNBOUNDED PRECEDING AND CURRENT ROW
                                   ) AS UMSATZ_KUM
FROM TBL_BESTELLUNG b
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
WHERE convert(VARCHAR(6), BESTELL_DATUM,112)='201301'
ORDER BY 1;

-- #####################################################################
--  KAP2: bung 6
-- #####################################################################

SELECT DISTINCT
        MONAT,
        UMSATZ_MONAT,
        MAX(UMSATZ_MONAT) OVER(ORDER BY cast(MONAT as decimal) ASC ROWS BETWEEN 1 PRECEDING AND 1 PRECEDING) AS UMSATZ_VORMONAT,
        UMSATZ_MONAT-MAX(UMSATZ_MONAT) OVER(ORDER BY cast(MONAT as decimal) ASC ROWS BETWEEN 1 PRECEDING AND 1 PRECEDING) AS DIFF_ABS,
        FIRST_VALUE(UMSATZ_TAG) OVER(PARTITION BY MONAT ORDER BY BESTELL_DATUM) AS UMSATZ_1ST_DAY--,
--        NTH_VALUE(UMSATZ_TAG,15) OVER(PARTITION BY MONAT ORDER BY BESTELL_DATUM ROWS BETWEEN UNBOUNDED PRECEDING AND UNBOUNDED FOLLOWING) AS UMSATZ_15TH_DAY
FROM (
        SELECT DISTINCT
            b.BESTELL_DATUM,
            convert(VARCHAR(6), BESTELL_DATUM,112) AS MONAT,
            SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY convert(VARCHAR(8), BESTELL_DATUM,112)) AS UMSATZ_TAG,
            SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY convert(VARCHAR(6), BESTELL_DATUM,112)) AS UMSATZ_MONAT
        FROM TBL_BESTELLUNG b
          JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
          JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
        WHERE convert(VARCHAR(6), BESTELL_DATUM,112) between '201301' and '201303'
) umsatz
ORDER BY 1;


-- #####################################################################
--  KAP2: Aufgabe 1
-- #####################################################################

SELECT DISTINCT
    convert(VARCHAR(4), BESTELL_DATUM,112)+
					CASE 
						WHEN substring(convert(VARCHAR(6), BESTELL_DATUM,112),5,2) IN(1,2,3) THEN '1' 
						WHEN substring(convert(VARCHAR(6), BESTELL_DATUM,112),5,2) IN(4,5,6) THEN '2'
						WHEN substring(convert(VARCHAR(6), BESTELL_DATUM,112),5,2) IN(7,8,9) THEN '3'
						ELSE '4'
					END AS QUARTAL,
    SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY convert(VARCHAR(4), BESTELL_DATUM,112)+
												CASE 
													WHEN substring(convert(VARCHAR(6), BESTELL_DATUM,112),5,2) IN(1,2,3) THEN '1' 
													WHEN substring(convert(VARCHAR(6), BESTELL_DATUM,112),5,2) IN(4,5,6) THEN '2'
													WHEN substring(convert(VARCHAR(6), BESTELL_DATUM,112),5,2) IN(7,8,9) THEN '3'
													ELSE '4'
												END) AS UMSATZ,
    COUNT(DISTINCT b.BESTELLUNG_NR) OVER(PARTITION BY convert(VARCHAR(4), BESTELL_DATUM,112)+
														CASE 
															WHEN substring(convert(VARCHAR(6), BESTELL_DATUM,112),5,2) IN(1,2,3) THEN '1' 
															WHEN substring(convert(VARCHAR(6), BESTELL_DATUM,112),5,2) IN(4,5,6) THEN '2'
															WHEN substring(convert(VARCHAR(6), BESTELL_DATUM,112),5,2) IN(7,8,9) THEN '3'
															ELSE '4'
														END) AS ANZ_BEST
FROM TBL_BESTELLUNG b
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
WHERE convert(VARCHAR(4), BESTELL_DATUM,112)='2013'
ORDER BY 1;


-- #####################################################################
--  KAP2: Aufgabe 2
-- #####################################################################

/* -- Kein RANGE between 1 PRECEDING and 1 FOLLOWING unter MSSQL erlaubt
SELECT DISTINCT
    b.BESTELL_DATUM,
    SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY b.BESTELL_DATUM) AS UMSATZ,
    SUM(bp.ANZAHL*p.PREIS) OVER(ORDER BY b.BESTELL_DATUM RANGE BETWEEN 1 PRECEDING AND 1 PRECEDING) AS UMSATZ_VORTAG,
    SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY b.BESTELL_DATUM)-
    SUM(bp.ANZAHL*p.PREIS) OVER(ORDER BY b.BESTELL_DATUM RANGE BETWEEN 1 PRECEDING AND 1 PRECEDING) AS ABWEICHUNG
FROM TBL_BESTELLUNG b
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
WHERE convert(VARCHAR(6), BESTELL_DATUM,112)='201302'
ORDER BY 1;
*/

SELECT DISTINCT
    ums.BESTELL_DATUM,
    UMSATZ,
    SUM(UMSATZ) OVER(ORDER BY BESTELL_DATUM ROWS BETWEEN 1 PRECEDING AND 1 PRECEDING) AS UMSATZ_VORTAG,
    UMSATZ-SUM(UMSATZ) OVER(ORDER BY BESTELL_DATUM ROWS BETWEEN 1 PRECEDING AND 1 PRECEDING) AS ABWEICHUNG
FROM (
		SELECT DISTINCT
			b.BESTELL_DATUM,
			SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY b.BESTELL_DATUM) AS UMSATZ
		FROM TBL_BESTELLUNG b
		  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
		  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
		WHERE convert(VARCHAR(6), BESTELL_DATUM,112)='201302'
) ums
ORDER BY 1;


-- #####################################################################
--  KAP2: Aufgabe 3
-- #####################################################################
SELECT *
FROM (
    SELECT DISTINCT
          KUNDE_NR,
          VORNAME,
          NACHNAME,
          UMSATZ,
          PRODUKT,
          RANK() OVER(PARTITION BY KUNDE_NR ORDER BY KUNDE_NR, UMSATZ_KD_PROD DESC) AS PROD_RANG 
    FROM (
          SELECT DISTINCT
                  k.KUNDE_NR,
                  k.VORNAME,
                  k.NACHNAME,
                  SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY k.KUNDE_NR) AS UMSATZ,
                  CAST(p.PRODUKT_NR AS VARCHAR)+' - '+p.BEZEICHNUNG AS PRODUKT,
                  SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY k.KUNDE_NR, p.PRODUKT_NR) AS UMSATZ_KD_PROD
          FROM TBL_KUNDE k
            JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
            JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
            JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
          WHERE convert(VARCHAR(6), BESTELL_DATUM,112)='201301'
    ) ums
) kunde
WHERE PROD_RANG=1
ORDER BY 1;

-- #####################################################################
--  KAP2: Aufgabe 4
-- #####################################################################


-- Da unter MSSQL kein RANGE BETWEEN 2 PRECEDING AND CURRENT ROW untersttzt wird, muss man das Statement auf ROWS umstellen

/* -- Oracle Version
SELECT DISTINCT
    convert(VARCHAR(6), BESTELL_DATUM,112) AS MONAT,
    SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY convert(VARCHAR(6), BESTELL_DATUM,112)) AS UMSATZ,
    SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY convert(VARCHAR(4), BESTELL_DATUM,112)
                                ORDER BY convert(VARCHAR(6), BESTELL_DATUM,112)
                                RANGE UNBOUNDED PRECEDING
                               ) AS UMSATZ_KUM,
    SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY convert(VARCHAR(4), BESTELL_DATUM,112)
                                ORDER BY CAST(convert(VARCHAR(6), BESTELL_DATUM,112) AS DECIMAL)
                                RANGE BETWEEN 2 PRECEDING AND CURRENT ROW
                               ) AS UMSATZ_LAST_3MON                              
FROM TBL_BESTELLUNG b
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
WHERE convert(VARCHAR(4), BESTELL_DATUM,112)='2013'
ORDER BY 1;

*/

SELECT DISTINCT
    MONAT,
    UMSATZ,
    SUM(UMSATZ) OVER(PARTITION BY substring(MONAT,1,4)
                                ORDER BY MONAT
                                ROWS UNBOUNDED PRECEDING
                               ) AS UMSATZ_KUM,
    SUM(UMSATZ) OVER(PARTITION BY substring(MONAT,1,4)
                                ORDER BY MONAT
                                ROWS BETWEEN 2 PRECEDING AND CURRENT ROW
                               ) AS UMSATZ_LAST_3MON                              
FROM (
		SELECT DISTINCT
			convert(VARCHAR(6), BESTELL_DATUM,112) AS MONAT,
			SUM(bp.ANZAHL*p.PREIS) OVER(PARTITION BY convert(VARCHAR(6), BESTELL_DATUM,112)) AS UMSATZ
		FROM TBL_BESTELLUNG b
		  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
		  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
		WHERE convert(VARCHAR(4), BESTELL_DATUM,112)='2013'
) ums
ORDER BY 1;



-- #####################################################################
--  KAP2: Aufgabe 5
-- #####################################################################

SELECT DISTINCT
      PRODUKT_NR,
      BEZEICHNUNG,
      SUM(UMSATZ) OVER(PARTITION BY PRODUKT_NR) AS UMSATZ,
      SUM(UMSATZ) OVER() AS UMSATZ_GES,
      round(SUM(UMSATZ) OVER(PARTITION BY PRODUKT_NR)/SUM(UMSATZ) OVER()*100,1) AS ANTEIL,
      FIRST_VALUE(MONAT) OVER(PARTITION BY PRODUKT_NR ORDER BY PRODUKT_NR, UMSATZ DESC) AS MONAT_MAX,
      FIRST_VALUE(MONAT) OVER(PARTITION BY PRODUKT_NR ORDER BY PRODUKT_NR, UMSATZ ASC) AS MONAT_MIN
FROM (
        SELECT  convert(VARCHAR(6), BESTELL_DATUM,112) AS MONAT,
                p.PRODUKT_NR,
                p.BEZEICHNUNG,
                SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
        FROM TBL_BESTELLUNG b
          JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
          JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
        WHERE convert(VARCHAR(4), BESTELL_DATUM,112)='2013'
        GROUP BY convert(VARCHAR(6), BESTELL_DATUM,112),
                p.PRODUKT_NR,
                p.BEZEICHNUNG
) ums
ORDER BY 1;

