-- #####################################################################
--  KAP3: Übung 1
-- #####################################################################

CREATE TABLE Test.dbo.TBL_MITARBEITER(
  MITARBEITER_NR	INTEGER NOT NULL,
  VORNAME	VARCHAR(30),
  NACHNAME VARCHAR(30),
  TYP	VARCHAR(20),
  GEHALT	NUMERIC(10,2),
  PROV_SATZ NUMERIC(10,6)
);


-- #####################################################################
--  KAP3: Übung 2
-- #####################################################################

DROP TABLE Test.dbo.TBL_KUNDE;

CREATE TABLE Test.dbo.TBL_KUNDE(
  KUNDE_NR	INTEGER NOT NULL ,
  VORNAME VARCHAR(25) NOT NULL,	
  NACHNAME VARCHAR(25) NOT NULL,
  STRASSE	 VARCHAR(50),
  PLZ	 VARCHAR(5),
  ORT	 VARCHAR(20),
  GESCHLECHT VARCHAR(1) CHECK(GESCHLECHT IN('M', 'm', 'F', 'f')),	
  GEBURTSTAG DATETIME DEFAULT convert(DATETIME, '01.01.1900', 104),
  CONSTRAINT PK_KUNDE PRIMARY KEY (KUNDE_NR)
);

CREATE TABLE Test.dbo.TBL_BESTELLUNG(
  BESTELLUNG_NR INTEGER NOT NULL,	
  BESTELL_DATUM DATETIME NOT NULL,	
  ABHOLER_FLAG BIT NOT NULL,	
  KUNDE_NR INTEGER NOT NULL,	
  FAHRER_NR	INTEGER,
  VERKAEUFER_NR INTEGER,
  CONSTRAINT PK_BESTELLUNG PRIMARY KEY (BESTELLUNG_NR),
  CONSTRAINT FK_BESTELLUNG_KUNDE FOREIGN KEY (KUNDE_NR)
      REFERENCES Test.dbo.TBL_KUNDE(KUNDE_NR)
);

-- #####################################################################
--  KAP3: Übung 3
-- #####################################################################

ALTER TABLE Test.dbo.TBL_KUNDE DROP COLUMN TEST;

ALTER TABLE Test.dbo.TBL_KUNDE ADD ERSTELLDATUM DATETIME DEFAULT GETDATE();

-- #####################################################################
--  KAP3: Übung 4
-- #####################################################################

ALTER TABLE Test.dbo.TBL_MITARBEITER ADD CONSTRAINT PK_MITARBEITER PRIMARY KEY (MITARBEITER_NR);
ALTER TABLE Test.dbo.TBL_BESTELLUNG ADD CONSTRAINT FK_BESTELLUNG_VERKAEUFER FOREIGN KEY (VERKAEUFER_NR)
	REFERENCES Test.dbo.TBL_MITARBEITER(MITARBEITER_NR);

-- #####################################################################
--  KAP3: Aufgabe 1
-- #####################################################################

INSERT INTO Test.dbo.TBL_KUNDE (KUNDE_NR, VORNAME, NACHNAME) VALUES(1, 'Hugo', 'Schmidt');

-- #####################################################################
--  KAP3: Aufgabe 2
-- #####################################################################

CREATE TABLE Test.dbo.TBL_BESTELLUNG_POS(
  BESTELLUNG_NR INTEGER NOT NULL,	
  PRODUKT_NR INTEGER NOT NULL	,
  ANZAHL INTEGER NOT NULL,
  CONSTRAINT PK_BESTELLUNG_POS PRIMARY KEY(BESTELLUNG_NR, PRODUKT_NR),
  CONSTRAINT FK_BEST_POS_BEST FOREIGN KEY(BESTELLUNG_NR)
    REFERENCES Test.dbo.TBL_BESTELLUNG(BESTELLUNG_NR)
);

INSERT INTO Test.dbo.TBL_BESTELLUNG VALUES(1, getdate(), 0, 1, 0, 0);

INSERT INTO Test.dbo.TBL_BESTELLUNG_POS VALUES(1,25,1);

-- #####################################################################
--  KAP3: Aufgabe 3
-- #####################################################################

ALTER TABLE Test.dbo.TBL_BESTELLUNG_POS ADD CONSTRAINT FK_BEST_POS_PRODUKT FOREIGN KEY(PRODUKT_NR)
  REFERENCES Test.dbo.TBL_PRODUKT(PRODUKT_NR);

--> Fehler tritt auf, weil das Produkt Nr. 1 nicht zur Bestell-Pos passt (dort wird auf Produkt Nr. 25 verwiesen)

UPDATE Test.dbo.TBL_BESTELLUNG_POS SET PRODUKT_NR=1 WHERE PRODUKT_NR=25;

ALTER TABLE Test.dbo.TBL_BESTELLUNG_POS ADD CONSTRAINT FK_BEST_POS_PRODUKT FOREIGN KEY(PRODUKT_NR)
  REFERENCES Test.dbo.TBL_PRODUKT(PRODUKT_NR);

-- #####################################################################
--  KAP3: Aufgabe 4
-- #####################################################################

DELETE Test.dbo.TBL_BESTELLUNG_POS;

DELETE Test.dbo.TBL_BESTELLUNG;

-- #####################################################################
--  KAP3: Aufgabe 5
-- #####################################################################

ALTER TABLE Test.dbo.TBL_KUNDE DROP COLUMN ERSTELLDATUM;

-- #####################################################################
--  KAP3: Aufgabe 6
-- #####################################################################

DELETE Test.dbo.TBL_PRODUKT;
DELETE Test.dbo.TBL_PRODUKTGRUPPE;
DELETE Test.dbo.TBL_KUNDE;

-- Skript Test.dbo.TBL_PRODUKTGRUPPE_INSERT ausführen
-- Skript Test.dbo.TBL_PRODUKT_INSERT ausführen
-- Skript Test.dbo.TBL_MITARBEITER_INSERT ausführen
-- Skript Test.dbo.TBL_KUNDE_INSERT ausführen
-- Skript Test.dbo.TBL_BESTELLUNG_INSERT ausführen
-- Skript Test.dbo.TBL_BESTELLUNG_POS_INSERT ausführen
