-- #####################################################################
--  KAP7: Übung 1
-- #####################################################################

SELECT  kunde.*,
        ort.ORT_UMSATZ,
        round(kunde.KUNDE_UMSATZ/ort.ORT_UMSATZ*100,1) AS ANTEIL
FROM (
        SELECT  k.KUNDE_NR,
                VORNAME||' '||NACHNAME AS KUNDE_NAME,
                k.ORT,
                SUM(bp.ANZAHL*p.PREIS) AS KUNDE_UMSATZ
        FROM Test.dbo.TBL_KUNDE k
          JOIN Test.dbo.TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
          JOIN Test.dbo.TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
          JOIN Test.dbo.TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
        GROUP BY k.KUNDE_NR, VORNAME, NACHNAME, k.ORT
      ) kunde
JOIN (
        SELECT  k.ORT,
                SUM(bp.ANZAHL*p.PREIS) AS ORT_UMSATZ
        FROM Test.dbo.TBL_KUNDE k
          JOIN Test.dbo.TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
          JOIN Test.dbo.TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
          JOIN Test.dbo.TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
        GROUP BY k.ORT
      ) ort
ON kunde.ORT=ort.ORT
ORDER BY 3,1;

-- #####################################################################
--  KAP7: Übung 2
-- #####################################################################

select  prod.produkt_nr,
        prod.bezeichnung as PROD_BEZEICHNUNG,
        grp_preis_avg.bezeichnung as GRP_BEZEICHNUNG,
        prod.preis,
        grp_preis_avg.avg_preis
from
(
    select grp.produkt_gruppe_nr, grp.bezeichnung, round(avg(p.preis),2) aS AVG_PREIS
    from Test.dbo.TBL_produktgruppe grp
      join Test.dbo.TBL_produkt p on grp.produkt_gruppe_nr=p.produkt_gruppe_nr
    group by grp.produkt_gruppe_nr, grp.bezeichnung
) grp_preis_avg
join Test.dbo.TBL_produkt prod on grp_preis_avg.produkt_gruppe_nr=prod.produkt_gruppe_nr
where prod.preis>grp_preis_avg.avg_preis
order by 1;

-- #####################################################################
--  KAP7: Übung 3
-- #####################################################################

SELECT  distinct bp.BESTELLUNG_NR
FROM Test.dbo.TBL_BESTELLUNG_POS bp 
WHERE PRODUKT_NR IN (
      
      SELECT  DISTINCT PRODUKT_NR
      FROM Test.dbo.TBL_PRODUKT p
      WHERE PREIS>8
);

-- #####################################################################
--  KAP7: Übung 4
-- #####################################################################

SELECT  distinct b.*
FROM Test.dbo.TBL_BESTELLUNG b
  JOIN Test.dbo.TBL_BESTELLUNG_POS bpos ON b.BESTELLUNG_NR=bpos.BESTELLUNG_NR
  JOIN Test.dbo.TBL_PRODUKT p ON bpos.PRODUKT_NR=p.PRODUKT_NR
WHERE p.PRODUKT_GRUPPE_NR IN (
      
      SELECT  PRODUKT_GRUPPE_NR
      FROM Test.dbo.TBL_PRODUKT p
      GROUP BY PRODUKT_GRUPPE_NR
      HAVING AVG(PREIS)>6
);

-- #####################################################################
--  KAP7: Übung 5
-- #####################################################################

SELECT *
FROM Test.dbo.TBL_MITARBEITER
WHERE GEHALT < 0.75*(
  SELECT AVG(GEHALT)
  FROM Test.dbo.TBL_MITARBEITER
);

-- #####################################################################
--  KAP7: Übung 6
-- #####################################################################

SELECT *
FROM Test.dbo.TBL_MITARBEITER m_main
WHERE GEHALT>(
    SELECT AVG(GEHALT)
    FROM Test.dbo.TBL_MITARBEITER m_sub
    WHERE m_sub.TYP=m_main.TYP
);

-- #####################################################################
--  KAP7: Übung 7
-- #####################################################################

CREATE TABLE Test.dbo.TBL_PROV_VERKAEUFER(
    VERKAEUFER_NR INTEGER,
    MONAT INTEGER,
    UMSATZ FLOAT,
    PROVISION FLOAT
);


INSERT INTO Test.dbo.TBL_PROV_VERKAEUFER (VERKAEUFER_NR, MONAT, UMSATZ)
SELECT  b.MITARBEITER_NR,
        convert(INTEGER,convert(VARCHAR(6), BESTELL_DATUM,112)) AS MONAT,
        SUM(bpos.ANZAHL*p.PREIS) AS UMSATZ
FROM Test.dbo.TBL_BESTELLUNG b
  JOIN Test.dbo.TBL_BESTELLUNG_POS bpos ON b.BESTELLUNG_NR=bpos.BESTELLUNG_NR
  JOIN Test.dbo.TBL_PRODUKT p ON bpos.PRODUKT_NR=p.PRODUKT_NR
GROUP BY  b.MITARBEITER_NR,
          convert(INTEGER,convert(VARCHAR(6), BESTELL_DATUM,112));
          
UPDATE Test.dbo.TBL_PROV_VERKAEUFER  --> Alias bei SQL Server nicht möglich im Update.
SET PROVISION=UMSATZ*(
    SELECT PROV_SATZ
    FROM Test.dbo.TBL_MITARBEITER m
    WHERE m.MITARBEITER_NR=Test.dbo.TBL_PROV_VERKAEUFER.VERKAEUFER_NR
);


select *
from Test.dbo.TBL_PROV_VERKAEUFER;

DELETE Test.dbo.TBL_PROV_VERKAEUFER
WHERE VERKAEUFER_NR NOT IN (
    SELECT MITARBEITER_NR
    FROM Test.dbo.TBL_MITARBEITER
    WHERE TYP='VERKÄUFER'
);

-- #####################################################################
--  KAP7: Aufgabe 1
-- #####################################################################

SELECT AVG(UMSATZ) AS AVG_UMSATZ
FROM (
    SELECT  b.BESTELLUNG_NR,
            SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
    FROM Test.dbo.TBL_BESTELLUNG b
      JOIN Test.dbo.TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
      JOIN Test.dbo.TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
    GROUP BY b.BESTELLUNG_NR
	) x

--> Ergebnis als SubQuery in 2. Abfrage verwenden:

SELECT  b.BESTELLUNG_NR,
        SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
FROM Test.dbo.TBL_BESTELLUNG b
  JOIN Test.dbo.TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN Test.dbo.TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
GROUP BY b.BESTELLUNG_NR
HAVING SUM(bp.ANZAHL*p.PREIS)>(
    SELECT AVG(UMSATZ) AS AVG_UMSATZ
    FROM (
        SELECT  b.BESTELLUNG_NR,
                SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
        FROM Test.dbo.TBL_BESTELLUNG b
          JOIN Test.dbo.TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
          JOIN Test.dbo.TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
        GROUP BY b.BESTELLUNG_NR
    ) x
); 

-- #####################################################################
--  KAP7: Aufgabe 2
-- #####################################################################

Select  BESTELL_DATUM,
        SUM(bp.ANZAHL*p.PREIS) AS UMSATZ,
        MAX(ums_pro_mon.UMSATZ) AS UMSATZ_PRO_MONAT
from Test.dbo.TBL_BESTELLUNG b
  JOIN Test.dbo.TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN Test.dbo.TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
  JOIN (

    Select  convert(VARCHAR(6),BESTELL_DATUM,112) AS MONAT,
            SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
    from Test.dbo.TBL_BESTELLUNG b
        JOIN Test.dbo.TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
        JOIN Test.dbo.TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
    WHERE BESTELL_DATUM BETWEEN convert(DATETIME, '01.01.2013', 104) AND convert(DATETIME, '31.03.2013', 104)
    GROUP BY convert(VARCHAR(6),BESTELL_DATUM,112)
    
  ) ums_pro_mon ON ums_pro_mon.MONAT=convert(VARCHAR(6),BESTELL_DATUM,112)
WHERE BESTELL_DATUM BETWEEN convert(DATETIME, '01.01.2013', 104) AND convert(DATETIME, '31.03.2013', 104)
GROUP BY BESTELL_DATUM
ORDER BY BESTELL_DATUM;


-- #####################################################################
--  KAP7: Aufgabe 3
-- #####################################################################

SELECT  a.*,
        b.*,
        round(a.UMSATZ/b.GESAMT_UMSATZ,2) AS ANTEIL
FROM
(
    SELECT  k.ORT,
            SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
    FROM Test.dbo.TBL_KUNDE k
      JOIN Test.dbo.TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
      JOIN Test.dbo.TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
      JOIN Test.dbo.TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
    GROUP BY k.ORT
) a,
(
    SELECT SUM(bp.ANZAHL*p.PREIS) AS GESAMT_UMSATZ
    FROM Test.dbo.TBL_BESTELLUNG_POS bp
      JOIN Test.dbo.TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
) b;

-- #####################################################################
--  KAP7: Aufgabe 4
-- #####################################################################

SELECT x.*
FROM (
    SELECT  k.KUNDE_NR,
            k.VORNAME,
            k.NACHNAME,
            SUM(bp.ANZAHL*p.PREIS) AS UMSATZ_KUNDE
    FROM Test.dbo.TBL_KUNDE k
          JOIN Test.dbo.TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
          JOIN Test.dbo.TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
          JOIN Test.dbo.TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
    GROUP BY k.KUNDE_NR,
            k.VORNAME,
            k.NACHNAME
) x
WHERE x.UMSATZ_KUNDE>0.45*
  (
    SELECT TOP 1 UMSATZ_KUNDE
    FROM (
        SELECT  k.KUNDE_NR,
                SUM(bp.ANZAHL*p.PREIS) AS UMSATZ_KUNDE
        FROM Test.dbo.TBL_KUNDE k
              JOIN Test.dbo.TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
              JOIN Test.dbo.TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
              JOIN Test.dbo.TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
        GROUP BY k.KUNDE_NR        
    ) x
	ORDER BY 1 DESC
  )
ORDER BY 1;

-- #####################################################################
--  KAP7: Aufgabe 5
-- #####################################################################

SELECT *
FROM Test.dbo.TBL_PRODUKTGRUPPE
WHERE PRODUKT_GRUPPE_NR NOT IN(
    SELECT DISTINCT p.PRODUKT_GRUPPE_NR
    FROM Test.dbo.TBL_BESTELLUNG_POS bp
      JOIN Test.dbo.TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
);

-- #####################################################################
--  KAP7: Aufgabe 6a
-- #####################################################################

SELECT * INTO Test.dbo.TBL_PRODUKT_TEST  FROM Test.dbo.TBL_PRODUKT WHERE 1=2;

INSERT INTO Test.dbo.TBL_PRODUKT_TEST
SELECT *
FROM Test.dbo.TBL_PRODUKT
WHERE PREIS>( SELECT AVG(PREIS) FROM Test.dbo.TBL_PRODUKT);


-- #####################################################################
--  KAP7: Aufgabe 6b
-- #####################################################################

ALTER TABLE Test.dbo.TBL_PRODUKT_TEST ADD AVG_PREIS_GRUPPE FLOAT;

UPDATE Test.dbo.TBL_PRODUKT_TEST
SET AVG_PREIS_GRUPPE= (
    SELECT AVG(PREIS) 
    FROM Test.dbo.TBL_PRODUKT p2
    WHERE p2.PRODUKT_GRUPPE_NR=Test.dbo.TBL_PRODUKT_TEST.PRODUKT_GRUPPE_NR
    );
    

-- #####################################################################
--  KAP7: Aufgabe 7
-- #####################################################################

SELECT TOP 3 x.*
from
(
    SELECT  p.PRODUKT_NR,
            p.BEZEICHNUNG,
            SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
    FROM Test.dbo.TBL_BESTELLUNG_POS bp
      JOIN Test.dbo.TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
    GROUP BY p.PRODUKT_NR,
            p.BEZEICHNUNG
) x
ORDER BY 3 DESC;

-- #####################################################################
--  KAP7: Aufgabe 8
-- #####################################################################

SELECT  a.*,
        (a.BEST_MAI/a.BEST_APRIL-1)*100 AS ABWEICHUNG
FROM (
    SELECT  m.VORNAME,
            m.NACHNAME,
            COUNT(DISTINCT b_april.BESTELLUNG_NR) AS BEST_APRIL,
            COUNT(DISTINCT b_mai.BESTELLUNG_NR) AS BEST_MAI
    FROM Test.dbo.TBL_MITARBEITER m
      JOIN Test.dbo.TBL_BESTELLUNG b_april ON b_april.FAHRER_NR=m.MITARBEITER_NR
      JOIN Test.dbo.TBL_BESTELLUNG b_mai ON b_mai.FAHRER_NR=m.MITARBEITER_NR
    WHERE convert(VARCHAR(6),b_april.BESTELL_DATUM,112)='201304'
    AND convert(VARCHAR(6),b_mai.BESTELL_DATUM,112)='201305'
    GROUP BY m.VORNAME,
            m.NACHNAME
) a;




-- #####################################################################
--  KAP7: Aufgabe 9
-- #####################################################################

SELECT DISTINCT ORT, PRODUKT_NR, BEZEICHNUNG
FROM Test.dbo.TBL_KUNDE kunde_main, Test.dbo.TBL_PRODUKT
WHERE PRODUKT_NR IN(
          SELECT TOP 1 x.PRODUKT_NR
          FROM(
              SELECT  k.ORT,
                      p.PRODUKT_NR,
                      p.BEZEICHNUNG,
                      SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
              FROM Test.dbo.TBL_KUNDE k
                JOIN Test.dbo.TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
                JOIN Test.dbo.TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
                JOIN Test.dbo.TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
              GROUP BY  k.ORT,
                        p.PRODUKT_NR,
                        p.BEZEICHNUNG
			  
          ) x        
          WHERE x.ORT=kunde_main.ORT        
		  ORDER BY x.UMSATZ DESC
)
ORDER BY 1,2;
