-- #####################################################################
--  KAP8: Übung 1
-- #####################################################################

SELECT 'Top', x.*
FROM (
    SELECT  TOP 2
			p.PRODUKT_NR,
            p.BEZEICHNUNG,
            SUM(p.PREIS*bp.ANZAHL) AS UMSATZ
    FROM Test.dbo.TBL_PRODUKT p
      JOIN Test.dbo.TBL_BESTELLUNG_POS bp ON p.PRODUKT_NR=bp.PRODUKT_NR
    GROUP BY p.PRODUKT_NR,p.BEZEICHNUNG
	ORDER BY 3 DESC
) x

UNION 

SELECT 'Flop', x.*
FROM (
    SELECT  TOP 2
			p.PRODUKT_NR,
            p.BEZEICHNUNG,
            SUM(p.PREIS*bp.ANZAHL) AS UMSATZ
    FROM Test.dbo.TBL_PRODUKT p
      JOIN Test.dbo.TBL_BESTELLUNG_POS bp ON p.PRODUKT_NR=bp.PRODUKT_NR
    GROUP BY p.PRODUKT_NR,p.BEZEICHNUNG
	ORDER BY 3 ASC
) x;



-- #####################################################################
--  KAP8: Übung 2
-- #####################################################################

-- In SQL Server nicht umsetzbar, da es den INTERSECT-Befehl nicht gibt.

-- #####################################################################
--  KAP8: Übung 3
-- #####################################################################

-- In SQL Server nicht umsetzbar, da es den MINUS-Befehl nicht gibt.

-- #####################################################################
--  KAP8: Aufgabe 1
-- #####################################################################

SELECT 'Hamburg' AS ORT, x.*
FROM (

    SELECT TOP 1 
            p.PRODUKT_NR,
            p.BEZEICHNUNG,
            SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
    FROM Test.dbo.TBL_KUNDE k
      JOIN Test.dbo.TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
      JOiN Test.dbo.TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
      JOIN Test.dbo.TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
    WHERE k.ORT='Hamburg'
    GROUP BY p.PRODUKT_NR,p.BEZEICHNUNG
    ORDER BY 3 DESC
) x


UNION

SELECT 'Kiel' AS ORT, y.*
FROM(
    SELECT  TOP 1
            p.PRODUKT_NR,
            p.BEZEICHNUNG,
            SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
    FROM Test.dbo.TBL_KUNDE k
      JOIN Test.dbo.TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
      JOiN Test.dbo.TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
      JOIN Test.dbo.TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
    WHERE k.ORT='Kiel'
    GROUP BY p.PRODUKT_NR,p.BEZEICHNUNG
	ORDER BY 3 DESC    
) y;


-- #####################################################################
--  KAP8: Aufgabe 2 
-- #####################################################################

-- In SQL Server nicht umsetzbar, da es den INTERSECT-Befehl nicht gibt.

-- #####################################################################
--  KAP8: Aufgabe 3 
-- #####################################################################

-- In SQL Server nicht umsetzbar, da es den MINUS-Befehl nicht gibt.

-- #####################################################################
--  KAP8: Aufgabe 4 
-- #####################################################################

SELECT NR, BEZEICHNUNG, UMSATZ
FROM (
    SELECT  p.PRODUKT_GRUPPE_NR*1000+p.PRODUKT_NR AS SORTIERUNG,
            p.PRODUKT_GRUPPE_NR+'-'+p.PRODUKT_NR AS NR,
            p.BEZEICHNUNG,
            SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
    FROM  Test.dbo.TBL_BESTELLUNG_POS bp
          JOIN Test.dbo.TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
    GROUP BY  p.PRODUKT_GRUPPE_NR*1000+p.PRODUKT_NR,
              p.PRODUKT_GRUPPE_NR+'-'+p.PRODUKT_NR,
              p.BEZEICHNUNG
    
    UNION
    
    SELECT  pg.PRODUKT_GRUPPE_NR*1000+999 AS SORTIERUNG,
            convert(VARCHAR,(pg.PRODUKT_GRUPPE_NR)),
            pg.BEZEICHNUNG,
            SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
    FROM  Test.dbo.TBL_BESTELLUNG_POS bp
          JOIN Test.dbo.TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
          JOIN Test.dbo.TBL_PRODUKTGRUPPE pg ON p.PRODUKT_GRUPPE_NR=pg.PRODUKT_GRUPPE_NR
    GROUP BY  pg.PRODUKT_GRUPPE_NR*1000,
              convert(VARCHAR,(pg.PRODUKT_GRUPPE_NR)),
              pg.BEZEICHNUNG
    
    UNION
    
    SELECT  100000 AS SORTIERUNG,
            '0',
            'GESAMT',
            SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
    FROM  Test.dbo.TBL_BESTELLUNG_POS bp
          JOIN Test.dbo.TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR

) x
ORDER BY 1;
