-- #####################################################################
--  KAP3: Demo 1
-- #####################################################################

CREATE TABLE TBL_KUNDE(
KUNDE_NR    NUMERIC(10,0) NOT NULL,
VORNAME   VARCHAR(25) NOT NULL,
NACHNAME   VARCHAR(25) NOT NULL,
STRASSE VARCHAR(50),
PLZ   VARCHAR(5),
ORT     VARCHAR(20),
GESCHLECHT VARCHAR(1) CHECK (GESCHLECHT IN('M', 'F', 'm', 'f')),
GEBURTSTAG DATE DEFAULT '01.01.1900'
);

-- #####################################################################
--  KAP3: Demo 2
-- #####################################################################

RENAME TABLE TBL_KUNDE TO TBL_KUNDE2;

-- #####################################################################
--  KAP3: Demo 3
-- #####################################################################

DROP TABLE TBL_KUNDE2;

-- #####################################################################
--  KAP3: Demo 4
-- #####################################################################

CREATE TABLE TBL_PRODUKTGRUPPE(
PRODUKT_GRUPPE_NR   NUMERIC(5,0) NOT NULL,
BEZEICHNUNG   VARCHAR(25),
CONSTRAINT PK_PRODGRUPPE PRIMARY KEY (PRODUKT_GRUPPE_NR)
);

-- #####################################################################
--  KAP3: Demo 5
-- #####################################################################

CREATE TABLE TBL_PRODUKT(
PRODUKT_NR   NUMERIC(5, 0) NOT NULL,
BEZEICHNUNG   VARCHAR(25),
PREIS   NUMERIC(10,2),
PRODUKT_GRUPPE_NR   NUMERIC(5, 0) NOT NULL,
CONSTRAINT PK_PRODUKT PRIMARY KEY (PRODUKT_NR),
CONSTRAINT FK_PROD_PROD_GRUPPE FOREIGN KEY (PRODUKT_GRUPPE_NR)
REFERENCES TBL_PRODUKTGRUPPE(PRODUKT_GRUPPE_NR)
);

-- #####################################################################
--  KAP3: Demo 6
-- #####################################################################

INSERT INTO TBL_PRODUKT VALUES(1, 'Rumpsteak', 20.95, 1);

COMMIT;

-- #####################################################################
--  KAP3: Demo 7
-- #####################################################################

INSERT INTO TBL_PRODUKTGRUPPE VALUES(1, 'Fleischgerichte');
COMMIT;

INSERT INTO TBL_PRODUKT VALUES(1, 'Rumpsteak', 20.95, 1);
COMMIT;

-- #####################################################################
--  KAP3: Demo 8
-- #####################################################################

-- FK Constraints können in MySQL nicht disabled werden. Deshalb kann man sie nur droppen.
ALTER TABLE TBL_PRODUKT DROP FOREIGN KEY FK_PRODUKT_PROD_GRUPPE;

-- #####################################################################
--  KAP3: Demo 9 (Seite 14)
-- #####################################################################

ALTER TABLE TBL_PRODUKT ADD CONSTRAINT FK_PRODUKT_PROD_GRUPPE FOREIGN KEY(PRODUKT_GRUPPE_NR)
						REFERENCES TBL_PRODUKTGRUPPE(PRODUKT_GRUPPE_NR);

-- #####################################################################
--  KAP3: Demo 10 (Seite 14)
-- #####################################################################

ALTER TABLE TBL_KUNDE ADD (TEST  VARCHAR(10) DEFAULT '0' NOT NULL);

-- #####################################################################
--  KAP3: Demo 11 (Seite 14)
-- #####################################################################

ALTER TABLE TBL_KUNDE MODIFY TEST NUMERIC DEFAULT -1;

-- #####################################################################
--  KAP3: Demo 12 (Seite 15)
-- #####################################################################

INSERT INTO TBL_KUNDE 
VALUES (1, 'Horst', 'Huber', 'Karolinenweg 11a', '20357', 'Hamburg', 'M', to_date('01.05.1947', 'DD.MM.YYYY'), null);

COMMIT;

-- #####################################################################
--  KAP3: Demo 13 (Seite 15)
-- #####################################################################

INSERT INTO TBL_KUNDE (KUNDE_NR, VORNAME, NACHNAME)
VALUES (2, 'Erika', 'Schmidt');

INSERT INTO TBL_KUNDE (KUNDE_NR, VORNAME, NACHNAME)
VALUES (3, 'Bert', 'Müller');

COMMIT;

-- #####################################################################
--  KAP3: Demo 14 (Seite 16)
-- #####################################################################

UPDATE TBL_KUNDE
SET Strasse='Goethestrasse 5', PLZ='22512', Ort='Hamburg'
WHERE KUNDE_NR=2;

UPDATE TBL_KUNDE
SET Strasse='Schwedenweg 22', PLZ='22123', Ort='Hamburg'
WHERE KUNDE_NR=3;

COMMIT;

-- #####################################################################
--  KAP3: Demo 15 (Seite 16)
-- #####################################################################

ALTER TABLE TBL_PRODUKT ADD (PREIS_NEU NUMERIC(10,2));

-- Unter MySQL muss man erst den SAFE Update Mode deaktvieren, damit man Löschen/Ändern kann wenn man auf
-- Nicht-PK-Spalten selektiert.
SET SQL_SAFE_UPDATES=0; 

UPDATE TBL_PRODUKT
SET PREIS_NEU=PREIS*5;

COMMIT;

SELECT *
FROM TBL_PRODUKT;

-- Safe Update Mode wieder einschalten
SET SQL_SAFE_UPDATES=1;

-- #####################################################################
--  KAP3: Demo 16 (Seite 16)
-- #####################################################################

DELETE FROM TBL_KUNDE
WHERE KUNDE_NR=2;

COMMIT;

SELECT *
FROM TBL_KUNDE;

-- #####################################################################
--  KAP3: Demo 17 (Seite 17)
-- #####################################################################

ALTER TABLE TBL_BESTELLUNG DROP FOREIGN KEY FK_BESTELLUNG_KUNDE;

TRUNCATE TABLE TBL_KUNDE;

ALTER TABLE TBL_BESTELLUNG ADD CONSTRAINT FK_BESTELLUNG_KUNDE FOREIGN KEY(KUNDE_NR)
							REFERENCES TBL_KUNDE(KUNDE_NR);

SELECT *
FROM TBL_KUNDE;
