-- #####################################################################
--  KAP9: Demo 1
-- #####################################################################

CREATE OR REPLACE VIEW V_KUNDEN_HAMBURG AS
SELECT *
FROM TBL_KUNDE
WHERE ORT='Hamburg';


SELECT KUNDE_NR, VORNAME, NACHNAME, PLZ, ORT
FROM V_KUNDEN_HAMBURG;

-- #####################################################################
--  KAP9: Demo 2
-- #####################################################################

CREATE VIEW V_ANZ_BESTELLUNGEN_KUNDEN_HH AS
SELECT  k.KUNDE_NR, k.VORNAME, k.NACHNAME, 
              Count(distinct b.BESTELLUNG_NR) AS ANZ_BESTELLUNGEN
FROM V_KUNDEN_HAMBURG k
     JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
GROUP BY k.KUNDE_NR, k.VORNAME, k.NACHNAME;

SELECT *
FROM V_ANZ_BESTELLUNGEN_KUNDEN_HH;

-- #####################################################################
--  KAP9: Demo 3
-- #####################################################################

DROP VIEW V_ANZ_BESTELLUNGEN_KUNDEN_HH;

-- #####################################################################
--  KAP9: Demo 4 
-- #####################################################################

GRANT SELECT ON TBL_KUNDE TO TEST2, TEST3;

-- #####################################################################
--  KAP9: Demo 5 
-- #####################################################################

REVOKE SELECT ON TBL_KUNDE FROM TEST2;

-- #####################################################################
--  KAP9: Demo 6 
-- #####################################################################

SELECT PRODUKT_NR, BEZEICHNUNG, UMSATZ,
             CASE
                 WHEN UMSATZ<700 THEN 'A'
                 WHEN UMSATZ BETWEEN 700 AND 1000 THEN 'B'
                 ELSE 'C'
             END AS UMSATZ_GRUPPE
FROM V_UMSATZ_PRODUKT
ORDER BY 3 ASC;

-- #####################################################################
--  KAP9: Demo 7 
-- #####################################################################

-- DECODE Funktion in MySQL hat andere Funktion als in Oracle.

SELECT x.*,
       CASE WHEN UMSATZ_GRUPPE='A' THEN '0...700€'
			WHEN UMSATZ_GRUPPE='B' THEN '>700€...1000€'
            ELSE'>1000€... '
	   END AS GRUPPE_BEZ 
FROM (
    SELECT PRODUKT_NR, BEZEICHNUNG, UMSATZ,
                 CASE
                     WHEN UMSATZ<700 THEN 'A'
                     WHEN UMSATZ BETWEEN 700 AND 1000 THEN 'B'
                     ELSE 'C'
                 END AS UMSATZ_GRUPPE
    FROM V_UMSATZ_PRODUKT
    ORDER BY 3 ASC
) x;

-- #####################################################################
--  KAP9: Demo 8 
-- #####################################################################

-- Analytische Funktionen werden in MySQL nicht unterstützt.

-- #####################################################################
--  KAP9: Demo 9
-- #####################################################################

-- Analytische Funktionen werden in MySQL nicht unterstützt.