-- #####################################################################
--  KAP3: bung 1
-- #####################################################################

SELECT k.ORT, k.KUNDE_NR, k.VORNAME, k.NACHNAME, SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
FROM TBL_KUNDE k
  JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
GROUP BY ROLLUP(k.ORT, (k.KUNDE_NR, k.VORNAME, k.NACHNAME))
ORDER BY ORT NULLS FIRST, KUNDE_NR NULLS FIRST;

-- #####################################################################
--  KAP3: bung 2
-- #####################################################################

SELECT to_char(b.BESTELL_DATUM,'YYYYMM') AS MONAT, 
       k.KUNDE_NR, k.VORNAME, k.NACHNAME,  COUNT(B.BESTELLUNG_NR) AS ANZ_BEST
FROM TBL_KUNDE k
  JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
GROUP BY ROLLUP(to_char(b.BESTELL_DATUM,'YYYYMM'), (k.KUNDE_NR, k.VORNAME, k.NACHNAME))
ORDER BY MONAT NULLS FIRST, KUNDE_NR NULLS FIRST;

-- #####################################################################
--  KAP3: bung 3
-- #####################################################################

SELECT to_char(b.BESTELL_DATUM,'YYYYMM') AS MONAT, 
       k.KUNDE_NR, k.VORNAME, k.NACHNAME, 
       SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
FROM TBL_KUNDE k
  JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
GROUP BY CUBE(to_char(b.BESTELL_DATUM,'YYYYMM'), (k.KUNDE_NR, k.VORNAME, k.NACHNAME))
ORDER BY to_char(b.BESTELL_DATUM,'YYYYMM') NULLS FIRST, KUNDE_NR NULLS FIRST;

-- #####################################################################
--  KAP3: bung 4
-- #####################################################################

SELECT to_char(b.BESTELL_DATUM,'YYYYMM') AS MONAT, 
       k.KUNDE_NR, k.VORNAME, k.NACHNAME, 
       p.PRODUKT_NR, p.BEZEICHNUNG,
       SUM(bp.ANZAHL*p.PREIS) AS UMSATZ,
       GROUPING(k.KUNDE_NR) AS GRP_KUNDE,
       GROUPING(p.PRODUKT_NR) AS GRP_PROD,
       GROUPING(to_char(b.BESTELL_DATUM,'YYYYMM')) AS GRP_MONAT
FROM TBL_KUNDE k
  JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
GROUP BY CUBE(to_char(b.BESTELL_DATUM,'YYYYMM'), (k.KUNDE_NR, k.VORNAME, k.NACHNAME), (p.PRODUKT_NR, p.BEZEICHNUNG))
HAVING  (GROUPING(k.KUNDE_NR)=0 AND GROUPING(p.PRODUKT_NR)=0 AND GROUPING(to_char(b.BESTELL_DATUM,'YYYYMM'))=0) OR -- Ebene Kunde/Produkt/Monat
        (GROUPING(k.KUNDE_NR)=1 AND GROUPING(p.PRODUKT_NR)=1 AND GROUPING(to_char(b.BESTELL_DATUM,'YYYYMM'))=0) OR -- Ebene Monat
        (GROUPING(k.KUNDE_NR)=0 AND GROUPING(p.PRODUKT_NR)=1 AND GROUPING(to_char(b.BESTELL_DATUM,'YYYYMM'))=1) OR -- Ebene Kunde
        (GROUPING(k.KUNDE_NR)=1 AND GROUPING(p.PRODUKT_NR)=1 AND GROUPING(to_char(b.BESTELL_DATUM,'YYYYMM'))=1)    -- Ebene Gesamt
ORDER BY to_char(b.BESTELL_DATUM,'YYYYMM') NULLS FIRST, KUNDE_NR NULLS FIRST;


-- #####################################################################
--  KAP3: bung 5
-- #####################################################################

SELECT to_char(b.BESTELL_DATUM,'YYYYMM') AS MONAT, 
       k.ORT, 
       SUM(bp.ANZAHL*p.PREIS) AS UMSATZ,
       GROUPING_ID(k.ORT, to_char(b.BESTELL_DATUM,'YYYYMM')) AS GRP_ID
FROM TBL_KUNDE k
  JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
GROUP BY CUBE(to_char(b.BESTELL_DATUM,'YYYYMM'), k.ORT)
HAVING GROUPING_ID(k.ORT, to_char(b.BESTELL_DATUM,'YYYYMM'))<>3
ORDER BY to_char(b.BESTELL_DATUM,'YYYYMM') NULLS FIRST, ORT NULLS FIRST;

-- #####################################################################
--  KAP3: bung 6
-- #####################################################################

SELECT to_char(b.BESTELL_DATUM,'YYYYQ') AS QUARTAL, 
       k.ORT, 
       SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
FROM TBL_KUNDE k
  JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
GROUP BY GROUPING SETS(to_char(b.BESTELL_DATUM,'YYYYQ'), k.ORT)
ORDER BY to_char(b.BESTELL_DATUM,'YYYYQ') NULLS FIRST, ORT NULLS FIRST;

-- #####################################################################
--  KAP3: Aufgabe 1
-- #####################################################################


SELECT  to_char(b.BESTELL_DATUM,'YYYY') AS JAHR, 
        to_char(b.BESTELL_DATUM,'YYYYQ') AS QUARTAL, 
        to_char(b.BESTELL_DATUM,'YYYYMM') AS MONAT, 
        SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
FROM TBL_BESTELLUNG b
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
GROUP BY ROLLUP(to_char(b.BESTELL_DATUM,'YYYY'), to_char(b.BESTELL_DATUM,'YYYYQ'), to_char(b.BESTELL_DATUM,'YYYYMM'))
ORDER BY JAHR NULLS FIRST, QUARTAL NULLS FIRST, MONAT NULLS FIRST;

-- #####################################################################
--  KAP3: Aufgabe 2
-- #####################################################################

SELECT to_char(b.BESTELL_DATUM,'YYYYMM') AS MONAT, 
       k.KUNDE_NR, k.VORNAME, k.NACHNAME, 
       SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
FROM TBL_KUNDE k
  JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
GROUP BY CUBE(to_char(b.BESTELL_DATUM,'YYYYMM'), (k.KUNDE_NR, k.VORNAME, k.NACHNAME))
ORDER BY MONAT NULLS FIRST, KUNDE_NR NULLS FIRST;

-- #####################################################################
--  KAP3: Aufgabe 3
-- #####################################################################

SELECT to_char(b.BESTELL_DATUM,'YYYYMM') AS MONAT, 
       k.ORT,
       pg.PRODUKT_GRUPPE_NR, pg.BEZEICHNUNG,
       SUM(bp.ANZAHL*p.PREIS) AS UMSATZ,
       GROUPING_ID(to_char(b.BESTELL_DATUM,'YYYYMM'), k.ORT, pg.PRODUKT_GRUPPE_NR) AS GRP_ID
FROM TBL_KUNDE k
  JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
  JOIN TBL_PRODUKTGRUPPE pg ON p.PRODUKT_GRUPPE_NR=pg.PRODUKT_GRUPPE_NR
GROUP BY CUBE(to_char(b.BESTELL_DATUM,'YYYYMM'), k.ORT, (pg.PRODUKT_GRUPPE_NR, pg.BEZEICHNUNG))
HAVING GROUPING_ID(to_char(b.BESTELL_DATUM,'YYYYMM'), k.ORT, pg.PRODUKT_GRUPPE_NR) IN(0,1,5,6,7)
ORDER BY MONAT NULLS FIRST, ORT NULLS FIRST, PRODUKT_GRUPPE_NR NULLS FIRST;

-- #####################################################################
--  KAP3: Aufgabe 4
-- #####################################################################

SELECT to_char(b.BESTELL_DATUM,'YYYYMM') AS MONAT, 
       k.KUNDE_NR, k.VORNAME, k.NACHNAME, 
       p.PRODUKT_NR, p.BEZEICHNUNG,
       SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
FROM TBL_KUNDE k
  JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
  JOIN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
GROUP BY GROUPING SETS(to_char(b.BESTELL_DATUM,'YYYYMM'),(p.PRODUKT_NR,p.BEZEICHNUNG), (k.KUNDE_NR, k.VORNAME, k.NACHNAME))
ORDER BY MONAT NULLS FIRST, KUNDE_NR NULLS FIRST, PRODUKT_NR NULLS FIRST;
