-- #####################################################################
--  KAP3: bung 1
-- #####################################################################

CREATE TABLE TBL_MITARBEITER(
  MITARBEITER_NR	NUMBER(10),
  VORNAME	VARCHAR2(30),
  NACHNAME VARCHAR2(30),
  TYP	VARCHAR2(20),
  GEHALT	NUMBER(10,2),
  PROV_SATZ NUMBER(10,2)
);


-- #####################################################################
--  KAP3: bung 2
-- #####################################################################

DROP TABLE TBL_KUNDE;

CREATE TABLE TBL_KUNDE(
  KUNDE_NR	NUMBER(10,0) NOT NULL ,
  VORNAME VARCHAR2(25) NOT NULL,	
  NACHNAME VARCHAR2(25) NOT NULL,
  STRASSE	 VARCHAR2(50),
  PLZ	 VARCHAR2(5),
  ORT	 VARCHAR2(20),
  GESCHLECHT VARCHAR2(1) CHECK(GESCHLECHT IN('M', 'm', 'F', 'f')),	
  GEBURTSTAG DATE DEFAULT TO_DATE('01.01.1900', 'DD.MM.YYYY'),
  CONSTRAINT PK_KUNDE PRIMARY KEY (KUNDE_NR)
);

CREATE TABLE TBL_BESTELLUNG(
  BESTELLUNG_NR NUMBER(10,0) NOT NULL,	
  BESTELL_DATUM DATE NOT NULL,	
  ABHOLER_FLAG NUMBER(1,0) NOT NULL,	
  KUNDE_NR NUMBER(10,0) NOT NULL,	
  FAHRER_NR	NUMBER(10,0),
  VERKAEUFER_NR NUMBER(10,0),
  CONSTRAINT PK_BESTELLUNG PRIMARY KEY (BESTELLUNG_NR),
  CONSTRAINT FK_BESTELLUNG_KUNDE FOREIGN KEY (KUNDE_NR)
      REFERENCES TBL_KUNDE(KUNDE_NR)
);

-- #####################################################################
--  KAP3: bung 3
-- #####################################################################

ALTER TABLE TBL_KUNDE DROP(TEST);

ALTER TABLE TBL_KUNDE ADD(ERSTELLDATUM DATE DEFAULT SYSDATE);

-- #####################################################################
--  KAP3: bung 4
-- #####################################################################

ALTER TABLE TBL_MITARBEITER ADD CONSTRAINT PK_MITARBEITER PRIMARY KEY (MITARBEITER_NR);
ALTER TABLE TBL_BESTELLUNG ADD CONSTRAINT FK_BESTELLUNG_VERKAEUFER FOREIGN KEY (VERKAEUFER_NR)
      REFERENCES TBL_MITARBEITER(VERKAEUFER_NR);

-- #####################################################################
--  KAP3: Aufgabe 1
-- #####################################################################

INSERT INTO TBL_KUNDE (KUNDE_NR, VORNAME, NACHNAME) VALUES(1, 'Hugo', 'Schmidt');

COMMIT;

-- #####################################################################
--  KAP3: Aufgabe 2
-- #####################################################################

CREATE TABLE TBL_BESTELLUNG_POS(
  BESTELLUNG_NR NUMBER(10) NOT NULL,	
  PRODUKT_NR NUMBER(10) NOT NULL	,
  ANZAHL NUMBER(10) NOT NULL,
  CONSTRAINT PK_BESTELLUNG_POS PRIMARY KEY(BESTELLUNG_NR, PRODUKT_NR),
  CONSTRAINT FK_BEST_POS_BEST FOREIGN KEY(BESTELLUNG_NR)
    REFERENCES TBL_BESTELLUNG(BESTELLUNG_NR)
);

INSERT INTO TBL_BESTELLUNG VALUES(1, sysdate, 0, 1, 0, 0);

commit;

INSERT INTO TBL_BESTELLUNG_POS VALUES(1,25,1);

commit;

-- #####################################################################
--  KAP3: Aufgabe 3
-- #####################################################################

ALTER TABLE TBL_BESTELLUNG_POS ADD CONSTRAINT FK_BEST_POS_PRODUKT FOREIGN KEY(PRODUKT_NR)
  REFERENCES TBL_PRODUKT(PRODUKT_NR);

--> Fehler, weil Produkt Nr.1 in Produkt Tabelle nicht zu Produkt Nr. 25 in Bestellung-Pos passt.
--> Wir ndern den Satz in Bestellung-Pos und erstellen den Constraint erneut.

UPDATE TBL_BESTELLUNG_POS SET PRODUKT_NR=1 WHERE PRODUKT_NR=25;

COMMIT;

ALTER TABLE TBL_BESTELLUNG_POS ADD CONSTRAINT FK_BEST_POS_PRODUKT FOREIGN KEY(PRODUKT_NR)
  REFERENCES TBL_PRODUKT(PRODUKT_NR);


-- #####################################################################
--  KAP3: Aufgabe 4
-- #####################################################################

DELETE TBL_BESTELLUNG_POS;

COMMIT;


DELETE TBL_BESTELLUNG;

COMMIT;

-- #####################################################################
--  KAP3: Aufgabe 5
-- #####################################################################

ALTER TABLE TBL_KUNDE DROP(ERSTELLDATUM);

-- #####################################################################
--  KAP3: Aufgabe 6
-- #####################################################################

DELETE TBL_PRODUKT;
DELETE TBL_PRODUKTGRUPPE;
DELETE TBL_KUNDE;
COMMIT;

-- Skript TBL_PRODUKTGRUPPE_INSERT ausfhren
-- Skript TBL_PRODUKT_INSERT ausfhren
-- Skript TBL_MITARBEITER_INSERT ausfhren
-- Skript TBL_KUNDE_INSERT ausfhren
-- Skript TBL_BESTELLUNG_INSERT ausfhren
-- Skript TBL_BESTELLUNG_POS_INSERT ausfhren
