-- #####################################################################
--  KAP8: bung 1
-- #####################################################################

SELECT 'Top', x.*
FROM (
    SELECT  p.PRODUKT_NR,
            p.BEZEICHNUNG,
            SUM(p.PREIS*bp.ANZAHL) AS UMSATZ
    FROM TBL_PRODUKT p
      JOIN TBL_BESTELLUNG_POS bp ON p.PRODUKT_NR=bp.PRODUKT_NR
    GROUP BY p.PRODUKT_NR,p.BEZEICHNUNG
    ORDER BY 3 DESC
) x
WHERE ROWNUM<=2

UNION

SELECT 'Flop', x.*
FROM (
    SELECT  p.PRODUKT_NR,
            p.BEZEICHNUNG,
            SUM(p.PREIS*bp.ANZAHL) AS UMSATZ
    FROM TBL_PRODUKT p
      JOIN TBL_BESTELLUNG_POS bp ON p.PRODUKT_NR=bp.PRODUKT_NR
    GROUP BY p.PRODUKT_NR,p.BEZEICHNUNG
    ORDER BY 3 ASC
) x
WHERE ROWNUM<=2
ORDER BY 4 DESC

-- #####################################################################
--  KAP8: bung 2
-- #####################################################################

SELECT  DISTINCT 
        p.PRODUKT_NR,
        p.BEZEICHNUNG        
FROM TBL_KUNDE k
  JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
  JOiN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
WHERE k.GESCHLECHT IN('m','M')

INTERSECT

SELECT  DISTINCT 
        p.PRODUKT_NR,
        p.BEZEICHNUNG        
FROM TBL_KUNDE k
  JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
  JOiN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
WHERE k.GESCHLECHT IN('f','F')

-- #####################################################################
--  KAP8: bung 3
-- #####################################################################

SELECT PRODUKT_NR, BEZEICHNUNG
FROM TBL_PRODUKT

MINUS

SELECT DISTINCT
        p.PRODUKT_NR,
        p.BEZEICHNUNG
FROM TBL_BESTELLUNG_POS bp
  JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR

-- #####################################################################
--  KAP8: Aufgabe 1
-- #####################################################################

SELECT *
FROM (

    SELECT  'Hamburg' AS ORT,
            p.PRODUKT_NR,
            p.BEZEICHNUNG,
            SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
    FROM TBL_KUNDE k
      JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
      JOiN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
      JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
    WHERE k.ORT='Hamburg'
    GROUP BY 'Hamburg', p.PRODUKT_NR,p.BEZEICHNUNG
    ORDER BY 4 DESC
)
where rownum=1

UNION

SELECT *
FROM(
    SELECT  'Kiel' AS ORT,
            p.PRODUKT_NR,
            p.BEZEICHNUNG,
            SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
    FROM TBL_KUNDE k
      JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
      JOiN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
      JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
    WHERE k.ORT='Kiel'
    GROUP BY 'Kiel', p.PRODUKT_NR,p.BEZEICHNUNG
    ORDER BY 4 DESC
)
WHERE rownum=1

-- #####################################################################
--  KAP8: Aufgabe 2
-- #####################################################################

SELECT ORT
FROM (
    SELECT k.ORT, SUM(bp.ANZAHL*p.PREIS)
    FROM TBL_KUNDE k
          JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
          JOiN TBL_BESTELLUNG_POS bp ON b.BESTELLUNG_NR=bp.BESTELLUNG_NR
          JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
    GROUP BY k.ORT
    ORDER BY 2 DESC
)
WHERE rownum<=2

INTERSECT

SELECT ORT
FROM (
    SELECT k.ORT, COUNT(distinct b.BESTELLUNG_NR)
    FROM TBL_KUNDE k
          JOIN TBL_BESTELLUNG b ON k.KUNDE_NR=b.KUNDE_NR
    GROUP BY k.ORT
    ORDER BY 2 DESC
)
WHERE rownum<=2

-- #####################################################################
--  KAP8: Aufgabe 3
-- #####################################################################

INSERT INTO TBL_PRODUKT_TEST (PRODUKT_NR, BEZEICHNUNG, PREIS, PRODUKT_GRUPPE_NR)
SELECT *
FROM TBL_PRODUKT
MINUS
SELECT PRODUKT_NR, BEZEICHNUNG, PREIS, PRODUKT_GRUPPE_NR
FROM TBL_PRODUKT_TEST;

COMMIT;

-- #####################################################################
--  KAP8: Aufgabe 4
-- #####################################################################

SELECT NR, BEZEICHNUNG, UMSATZ
FROM (
    SELECT  p.PRODUKT_GRUPPE_NR*1000+p.PRODUKT_NR AS SORTIERUNG,
            p.PRODUKT_GRUPPE_NR||'-'||p.PRODUKT_NR AS NR,
            p.BEZEICHNUNG,
            SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
    FROM  TBL_BESTELLUNG_POS bp
          JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
    GROUP BY  p.PRODUKT_GRUPPE_NR*1000+p.PRODUKT_NR,
              p.PRODUKT_GRUPPE_NR||'-'||p.PRODUKT_NR,
              p.BEZEICHNUNG
    
    UNION
    
    SELECT  pg.PRODUKT_GRUPPE_NR*1000+999 AS SORTIERUNG,
            to_char(pg.PRODUKT_GRUPPE_NR),
            pg.BEZEICHNUNG,
            SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
    FROM  TBL_BESTELLUNG_POS bp
          JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
          JOIN TBL_PRODUKTGRUPPE pg ON p.PRODUKT_GRUPPE_NR=pg.PRODUKT_GRUPPE_NR
    GROUP BY  pg.PRODUKT_GRUPPE_NR*1000,
              to_char(pg.PRODUKT_GRUPPE_NR),
              pg.BEZEICHNUNG
    
    UNION
    
    SELECT  100000 AS SORTIERUNG,
            '0',
            'GESAMT',
            SUM(bp.ANZAHL*p.PREIS) AS UMSATZ
    FROM  TBL_BESTELLUNG_POS bp
          JOIN TBL_PRODUKT p ON bp.PRODUKT_NR=p.PRODUKT_NR
    GROUP BY  10000, '0', 'GESAMT'
) 
ORDER BY SORTIERUNG
